tomcat-7.sh 6.7 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143
  1. #!/bin/bash
  2. # Author: yeho <lj2007331 AT gmail.com>
  3. # BLOG: https://linuxeye.com
  4. #
  5. # Notes: OneinStack for CentOS/RedHat 7+ Debian 9+ and Ubuntu 16+
  6. #
  7. # Project home page:
  8. # https://oneinstack.com
  9. # https://github.com/oneinstack/oneinstack
  10. Install_Tomcat7() {
  11. pushd ${oneinstack_dir}/src > /dev/null
  12. . /etc/profile
  13. id -g ${run_group} >/dev/null 2>&1
  14. [ $? -ne 0 ] && groupadd ${run_group}
  15. id -u ${run_user} >/dev/null 2>&1
  16. [ $? -ne 0 ] && useradd -g ${run_group} -M -s /bin/bash ${run_user} || { [ -z "$(grep ^${run_user} /etc/passwd | grep '/bin/bash')" ] && usermod -g ${run_group} -s /bin/bash ${run_user}; }
  17. # install apr
  18. if [ ! -e "${apr_install_dir}/bin/apr-1-config" ]; then
  19. tar xzf apr-${apr_ver}.tar.gz
  20. pushd apr-${apr_ver} > /dev/null
  21. ./configure --prefix=${apr_install_dir}
  22. make -j ${THREAD} && make install
  23. popd > /dev/null
  24. rm -rf apr-${apr_ver}
  25. fi
  26. tar xzf apache-tomcat-${tomcat7_ver}.tar.gz
  27. [ ! -d "${tomcat_install_dir}" ] && mkdir -p ${tomcat_install_dir}
  28. /bin/cp -R apache-tomcat-${tomcat7_ver}/* ${tomcat_install_dir}
  29. rm -rf ${tomcat_install_dir}/webapps/{docs,examples,host-manager,manager,ROOT/*}
  30. if [ ! -e "${tomcat_install_dir}/conf/server.xml" ]; then
  31. rm -rf ${tomcat_install_dir}
  32. echo "${CFAILURE}Tomcat install failed, Please contact the author! ${CEND}" && lsb_release -a
  33. kill -9 $$; exit 1;
  34. fi
  35. /bin/cp catalina-jmx-remote.jar ${tomcat_install_dir}/lib
  36. pushd ${tomcat_install_dir}/bin > /dev/null
  37. tar xzf tomcat-native.tar.gz
  38. pushd tomcat-native-*-src/native > /dev/null
  39. if [ "${armplatform}" == "y" ]; then
  40. ./configure --prefix=${apr_install_dir} --with-apr=${apr_install_dir}
  41. else
  42. ./configure --prefix=${apr_install_dir} --with-apr=${apr_install_dir} --with-ssl=${openssl_install_dir}
  43. fi
  44. make -j ${THREAD} && make install
  45. popd > /dev/null
  46. rm -rf tomcat-native-*
  47. if [ -e "${apr_install_dir}/lib/libtcnative-1.la" ]; then
  48. [ ${Mem} -le 768 ] && let Xms_Mem="${Mem}/3" || Xms_Mem=256
  49. let XmxMem="${Mem}/2"
  50. cat > ${tomcat_install_dir}/bin/setenv.sh << EOF
  51. JAVA_OPTS='-Djava.security.egd=file:/dev/./urandom -server -Xms${Xms_Mem}m -Xmx${XmxMem}m -Dfile.encoding=UTF-8'
  52. CATALINA_OPTS="-Djava.library.path=${apr_install_dir}/lib"
  53. # -Djava.rmi.server.hostname=$IPADDR
  54. # -Dcom.sun.management.jmxremote.password.file=\$CATALINA_BASE/conf/jmxremote.password
  55. # -Dcom.sun.management.jmxremote.access.file=\$CATALINA_BASE/conf/jmxremote.access
  56. # -Dcom.sun.management.jmxremote.ssl=false"
  57. EOF
  58. chmod +x ./*.sh
  59. /bin/mv ${tomcat_install_dir}/conf/server.xml{,_bk}
  60. popd # goto ${oneinstack_dir}/src
  61. /bin/cp ${oneinstack_dir}/config/server.xml ${tomcat_install_dir}/conf
  62. sed -i "s@/usr/local/tomcat@${tomcat_install_dir}@g" ${tomcat_install_dir}/conf/server.xml
  63. if [ ! -e "${nginx_install_dir}/sbin/nginx" -a ! -e "${tengine_install_dir}/sbin/nginx" -a ! -e "${openresty_install_dir}/nginx/sbin/nginx" -a ! -e "${apache_install_dir}/bin/httpd" ]; then
  64. if [ "${PM}" == 'yum' ]; then
  65. if [ -n "`grep 'dport 80 ' /etc/sysconfig/iptables`" ] && [ -z "$(grep -w '8080' /etc/sysconfig/iptables)" ]; then
  66. iptables -I INPUT 5 -p tcp -m state --state NEW -m tcp --dport 8080 -j ACCEPT
  67. service iptables save
  68. ip6tables -I INPUT 5 -p tcp -m state --state NEW -m tcp --dport 8080 -j ACCEPT
  69. service ip6tables save
  70. fi
  71. elif [ "${PM}" == 'apt-get' ]; then
  72. if [ -e '/etc/iptables/rules.v4' ]; then
  73. if [ -n "`grep 'dport 80 ' /etc/iptables/rules.v4`" ] && [ -z "$(grep -w '8080' /etc/iptables/rules.v4)" ]; then
  74. iptables -I INPUT 5 -p tcp -m state --state NEW -m tcp --dport 8080 -j ACCEPT
  75. iptables-save > /etc/iptables/rules.v4
  76. ip6tables -I INPUT 5 -p tcp -m state --state NEW -m tcp --dport 8080 -j ACCEPT
  77. ip6tables-save > /etc/iptables/rules.v6
  78. fi
  79. elif [ -e '/etc/iptables.up.rules' ]; then
  80. if [ -n "`grep 'dport 80 ' /etc/iptables.up.rules`" ] && [ -z "$(grep -w '8080' /etc/iptables.up.rules)" ]; then
  81. iptables -I INPUT 5 -p tcp -m state --state NEW -m tcp --dport 8080 -j ACCEPT
  82. iptables-save > /etc/iptables.up.rules
  83. fi
  84. fi
  85. fi
  86. fi
  87. [ ! -d "${tomcat_install_dir}/conf/vhost" ] && mkdir ${tomcat_install_dir}/conf/vhost
  88. cat > ${tomcat_install_dir}/conf/vhost/localhost.xml << EOF
  89. <Host name="localhost" appBase="${wwwroot_dir}/default" unpackWARs="true" autoDeploy="true">
  90. <Context path="" docBase="${wwwroot_dir}/default" reloadable="false" crossContext="true"/>
  91. <Valve className="org.apache.catalina.valves.AccessLogValve" directory="logs"
  92. prefix="localhost_access_log" suffix=".txt" pattern="%h %l %u %t &quot;%r&quot; %s %b" />
  93. <Valve className="org.apache.catalina.valves.RemoteIpValve" remoteIpHeader="X-Forwarded-For"
  94. protocolHeader="X-Forwarded-Proto" protocolHeaderHttpsValue="https"/>
  95. </Host>
  96. EOF
  97. # logrotate tomcat catalina.out
  98. cat > /etc/logrotate.d/tomcat << EOF
  99. ${tomcat_install_dir}/logs/catalina.out {
  100. daily
  101. rotate 5
  102. missingok
  103. dateext
  104. compress
  105. notifempty
  106. copytruncate
  107. }
  108. EOF
  109. [ -z "$(grep '<user username="admin" password=' ${tomcat_install_dir}/conf/tomcat-users.xml)" ] && sed -i "s@^</tomcat-users>@<role rolename=\"admin-gui\"/>\n<role rolename=\"admin-script\"/>\n<role rolename=\"manager-gui\"/>\n<role rolename=\"manager-script\"/>\n<user username=\"admin\" password=\"$(cat /dev/urandom | head -1 | md5sum | head -c 10)\" roles=\"admin-gui,admin-script,manager-gui,manager-script\"/>\n</tomcat-users>@" ${tomcat_install_dir}/conf/tomcat-users.xml
  110. cat > ${tomcat_install_dir}/conf/jmxremote.access << EOF
  111. monitorRole readonly
  112. controlRole readwrite \
  113. create javax.management.monitor.*,javax.management.timer.* \
  114. unregister
  115. EOF
  116. cat > ${tomcat_install_dir}/conf/jmxremote.password << EOF
  117. monitorRole $(cat /dev/urandom | head -1 | md5sum | head -c 8)
  118. # controlRole R&D
  119. EOF
  120. chown -R ${run_user}:${run_group} ${tomcat_install_dir}
  121. /bin/cp ${oneinstack_dir}/init.d/Tomcat-init /etc/init.d/tomcat
  122. sed -i "s@JAVA_HOME=.*@JAVA_HOME=${JAVA_HOME}@" /etc/init.d/tomcat
  123. sed -i "s@^CATALINA_HOME=.*@CATALINA_HOME=${tomcat_install_dir}@" /etc/init.d/tomcat
  124. sed -i "s@^TOMCAT_USER=.*@TOMCAT_USER=${run_user}@" /etc/init.d/tomcat
  125. [ "${PM}" == 'yum' ] && { chkconfig --add tomcat; chkconfig tomcat on; }
  126. [ "${PM}" == 'apt-get' ] && update-rc.d tomcat defaults
  127. echo "${CSUCCESS}Tomcat installed successfully! ${CEND}"
  128. rm -rf apache-tomcat-${tomcat7_ver}
  129. else
  130. popd > /dev/null
  131. echo "${CFAILURE}Tomcat install failed, Please contact the author! ${CEND}" && lsb_release -a
  132. fi
  133. service tomcat start
  134. popd > /dev/null
  135. }